#include <cstdio>
using namespace std;

int n, m;
int** mat;
void DB(){
	int i, j;
	for(i=0; i<n; i++){
		for(j=0; j<n; j++)
			printf("%d ", mat[i][j]);
		printf("\n");
	}
}
bool f(int i, int uj, int znak){
	int vrsta;
	int j;
	int p = -1;

	while(true){
		vrsta=0;
		j = uj;
		while(true){
			if(znak!=mat[i][j])
				break;
			mat[i][j] = 0;
			vrsta++;
			j++;
		}
		if(vrsta==0)
			break;

		if(!(vrsta==p || p==-1))
			return false;

		if(i==n-1)
			break;
		i++;
		p=vrsta;
	}
	return true;
}

int main(){
	int *niz = new int[10000001](); 
	int i, j;
	int res=0;
	int znak;
	scanf("%d%d", &n, &m);
	mat = new int*[n];
	for(i=0; i<n; i++){
		mat[i] = new int[m];
		for(j=0; j<n; j++)
			scanf("%d", &mat[i][j]);
	}

	for(i=0; i<n; i++)
		for(j=0; j<n; j++){
			znak = mat[i][j];
			if(znak!=0){
				if(f(i, j, znak)){
					if(niz[znak]==0){
						res++;
						niz[znak]++;
					}
					else if(niz[znak]==1){
						res--;
						niz[znak]++;
					}

				}
				else if(niz[znak]==0){
					niz[znak]=2;
				}
				else if(niz[znak]==1){
					res--;
					niz[znak]++;
				}
				
			}
		}

	printf("%d\n", res);
	return 0;
}